/* definitions generated by preprocessor, copy into defines.h */
#ifndef        PPINC
#define        _ATMEGA32        // device select: _ATMEGAxxxx
#define        _B1024        // boot size select: _Bxxxx (words), powers of two only
#ifdef        __ICCAVR__
#include        "iom32.h"
#endif
#if        __GNUC__
#include        <avr/io.h>
#endif

/* define pin for enter-self-prog-mode */
#define        PROGPORT        PORTA
#define        PROGPIN        PINA
#define        PROG_NO        PD6

/* baud rate register value calculation */
#define        CPU_FREQ        16000000
#define        BAUD_RATE        19200
#define        BRREG_VALUE        51

/* definitions for UART control */
#define        BAUD_RATE_LOW_REG        UBRRL
#define        UART_CONTROL_REG        UCSRB
#define        ENABLE_TRANSMITTER_BIT        TXEN
#define        ENABLE_RECEIVER_BIT        RXEN
#define        UART_STATUS_REG        UCSRA
#define        TRANSMIT_COMPLETE_BIT        TXC
#define        RECEIVE_COMPLETE_BIT        RXC
#define        UART_DATA_REG        UDR

/* definitions for SPM control */
#define        SPMCR_REG        SPMCR
#define        PAGESIZE        128
#define        APP_END        30720
//#define        LARGE_MEMORY

/* definitions for device recognition */
#define        PARTCODE        0x7F
#define        SIGNATURE_BYTE_1        0x1E
#define        SIGNATURE_BYTE_2        0x95
#define        SIGNATURE_BYTE_3        0x02

/* indicate that preprocessor result is included */
#define        PPINC



//------------------------------------------------------------------------
// Port Definitions (aus config.h)
//------------------------------------------------------------------------
// Port A
#define S88DIN1    0     // in
#define S88DIN2    1     // in
#define S88DIN3    2     // in
#define EXT_STOP   3     // in
#define LED_GO     4     // out
#define LED_STOP   5     // out
#define KEY_STOP   6     // in
#define KEY_GO     7     // in
// Port B
#define S88_CLK    0     // out
#define S88_RESET  1     // out
#define ACK_DETECT 2     // in    this is only a short pulse -> use int!
#define S88_LOAD   3     // out
#define DMX_OUT    4     // out
#define MY_CTS     6     // out
#define MY_RTS     7     // in
// Port C
#define SHORT_MAIN 0     // in
#define SHORT_PROG 1     // in
#define LED_CTRL   6     // out
#define LED_RS232  7     // out
// Port D
#define MY_RXD     0     // in
#define MY_TXD     1     // out
#define JUMPER1    2     // in
#define JUMPER2    3     // in
#define NDCC       4     // out
#define DCC        5     // out
#define ENA_PROG   6     // out  high = enable programming
#define ENA_MAIN   7     // out  high = enable main

#define LED_CTRL_ON      PORTC &= ~(1<<LED_CTRL)
#define LED_CTRL_OFF     PORTC |= (1<<LED_CTRL)
#define LED_RS232_ON     PORTC &= ~(1<<LED_RS232)
#define LED_RS232_OFF    PORTC |= (1<<LED_RS232)
#define LED_GO_ON        PORTA &= ~(1<<LED_GO)
#define LED_GO_OFF       PORTA |= (1<<LED_GO)
#define LED_STOP_ON      PORTA &= ~(1<<LED_STOP)
#define LED_STOP_OFF     PORTA |= (1<<LED_STOP)

#define KEY_STOP_PRESSED (!(PINA & (1<<KEY_STOP)))

//Hardware-Interface ---> new definitions
//LED grn
#define                LED_GN_OFF               PORTA |= (1<<LED_GO)
#define                LED_GN_ON                PORTA &= ~(1<<LED_GO)
#define                LED_GN_TOG               PORTA ^= (1<<LED_GO)
//LED rot
#define                LED_RT_OFF               PORTA |= (1<<LED_STOP)
#define                LED_RT_ON                PORTA &= ~(1<<LED_STOP)
#define                LED_RT_TOG               PORTA ^= (1<<LED_STOP)



#endif
